import java.util.Scanner;

/**
 * This game is a basic Wheel of Fortune game (but with no big wheel).
 * 
 * @author !!! PUT YOUR NAME HERE !!!
 * @version !!! PUT DATE HERE !!!
 * ---------------------------
 * spring 2012
 * ---------------------------
 */
public class PhraseGuesser {
    // instance variables: do not modify
    private char[] phrase;      // secret puzzle
    private boolean[] show;     // determines which characters of the puzzle to display
    
    /**
     * main
     * creates a PhraseGuess game object and plays the game
     * DO NOT MODIFY this method
     */
    public static void main(String[] args) {
        PhraseGuesser game = new PhraseGuesser();
        game.play();
    }
    
    /**
     * initPhrase
     * initializes the phrase instance variable to the mystery phrase
     */
    // MODIFY THIS METHOD
    private void initPhrase() {
        // note: must be in all capital letters for guessing to work
        // EDIT THIS WITH YOUR OWN PHRASES AND TO CHOOSE A RANDOM PHRASE FOR
        // THE PUZZLE
        // Put at least 10 phrases in puzzles, use capital letters for the puzzles
        String[] puzzles = {"TO BE OR NOT TO BE", 
                            "WALKING ON SUNSHINE", 
                            "HOME IS WHERE THE HEART IS"};
        String puzzle = puzzles[0]; 
        // (int) (Math.random() * 10)  -- gives you a random int from 0 to 9, which you can
        // use to randomly select one of your puzzles
        // right now the code always selects the puzzle in the 0th position in the array as the puzzle
        phrase = puzzle.toCharArray();
    }
    
    /** 
     * initShow
     * initializes the show array such that if the phrase has a ' ' character,
     * then the corresponding position in the show array should be true; otherwise,
     * the corresponding position in the show array should be false
     */
    // MODIFY THIS METHOD
    private void initShow() {
        // fill in
    }
    
    /**
     * printPhrase
     * prints the character in the phrase if the corresponding position in 
     * the show array is true; otherwise, prints a '*' for that position
     */
    // MODIFY THIS METHOD
    private void printPhrase() {
        // fill in
    }
    
    /**
     * revealLetter
     * @param letter that represents the user's guess
     * for each character in the phrase, checks to see if the letter is that
     * character and has not already been revealed (the show array at that
     * position is false): if so, the show array is updated to true at that
     * position
     * @return true if a new letter in the puzzle is revealed and false if
     * no new letters are revealed
     */
    // MODIFY THIS METHOD
    private boolean revealLetter(char letter) {
        return true;  // delete and fill in
    }
    
    /**
     * isWinner
     * if all positions in the show array are true, then the puzzle has
     * been solved
     * @return true if the puzzle is completely revealed and false if there
     * are more letters to guess
     */
    // MODIFY THIS METHOD
    private boolean isWinner() {
        return true; // delete and fill in
    }
    
    /**
     * play
     * game loop to play the game: initializes the phrase, repeatedly asks user
     * to enter letters until the puzzle is completely solved
     * DO NOT MODIFY
     */
    // DONE FOR YOU: DO NOT MODIFY
    private void play() {
        boolean noWinner = true;
        int numCorrectGuesses = 0;
        int numIncorrectGuesses = 0;
        
        // initialize puzzle
        initPhrase();
        initShow();
        
        // greet user and print mystery phrase
        System.out.println("Welcome to the phrase guessing game.");
        System.out.println("Guess the phrase, one letter at a time.");
        System.out.println("Here is your phrase:");
        printPhrase();
        
        char letter;
        // game loop
        while(noWinner) {
            // prompt user for letter (note that if they enter more than
            // one letter then the first letter of the word is treated
            // as the entered letter)
            do{
                System.out.println("Enter a letter (a - z or A - Z)");
                Scanner keyboard = new Scanner(System.in);
                String letterAsString = keyboard.nextLine();
                // convert to uppercase for character match
                letterAsString = letterAsString.toUpperCase();
                letter = letterAsString.charAt(0);
            }
            while(!Character.isLetter(letter));
            
            // see if letter is in puzzle and update the show array if it is
            boolean correctNewGuess = revealLetter(letter);
            
            // update score for user
            if(correctNewGuess) {
                numCorrectGuesses++;
            } else {
                numIncorrectGuesses++;
            }
            
            printPhrase();
            
            // check for winner
            if(isWinner()) {
                noWinner = false;
            }         
        }
        
        // say goodbye and reveal user's score
        System.out.println("Thank you for playing the phrase guesser.");
        System.out.println("You had " + numCorrectGuesses + " correct guess(es)");
        System.out.println("You had " + numIncorrectGuesses + " incorrect guess(es)");
    }
}
